#ifndef KRIMI_DINNER_ENGINE_TEXTURE_H
#define KRIMI_DINNER_ENGINE_TEXTURE_H

/// @file Texture.h
/// @brief Texture object

#include <GLES3/gl3.h>

class Renderer;

/// @brief A opengl texture
class Texture
{
public:
    Texture() : m_texture(0) {}
    Texture(unsigned int width, unsigned int height, const void* data);
    Texture(const Texture&) = default;
    Texture(Texture&&) = default;
    Texture& operator=(const Texture&) = default;

    /// @brief Destroys the texture
    void destroy();

    /// @brief Binds the texture to @c GL_TEXTURE_2D
    void bind() const;

private:
    GLuint m_texture;
};

#endif
